package cn.yyxx.eyuangame.core.impl.floatball

import android.app.Activity
import android.app.Service
import android.content.Intent
import android.os.Binder
import android.os.IBinder
import android.widget.ImageView
import cn.yyxx.eyuangame.base.utils.Logger
import cn.yyxx.eyuangame.core.entity.FloatFeature
import cn.yyxx.eyuangame.core.impl.SdkBridgeImpl
import cn.yyxx.eyuangame.core.impl.center.MemberActivity
import cn.yyxx.eyuangame.core.ui.floatview.FloatingBall
import cn.yyxx.eyuangame.core.ui.floatview.FloatingBallMenu
import cn.yyxx.support.ResUtils

/**
 * @author #Suyghur.
 * Created on 2021/06/28
 */
class FloatCenterService : Service() {

//    private var floatCenter: FloatLogoMenu? = null

    private var floatingBall: FloatingBall? = null
    private var mActivity: Activity? = null

    private val callback = object : FloatingBall.FloatingBallCallback {
        override fun onUpdateBallView(ballView: ImageView, isLeftLocation: Boolean, isHide: Boolean) {
            ballView.setBackgroundResource(ResUtils.getResId(mActivity, "yyxx_float_logo_img", "drawable"))
        }

        override fun onInitMenuData(): MutableList<FloatingBallMenu.FloatingBallMenuItem> {
            return mutableListOf(
                FloatingBallMenu.FloatingBallMenuItem(FloatFeature.FEATURE_MEMBER, "", ""),
                FloatingBallMenu.FloatingBallMenuItem(FloatFeature.FEATURE_GIF, "", ""),
                FloatingBallMenu.FloatingBallMenuItem(FloatFeature.FEATURE_GM, "", ""),
                FloatingBallMenu.FloatingBallMenuItem(FloatFeature.FEATURE_CHARGE, "", ""),
                FloatingBallMenu.FloatingBallMenuItem(FloatFeature.FEATURE_INVITE, "", "")
            )
        }

        override fun onMenuItemClick(item: FloatingBallMenu.FloatingBallMenuItem, pos: Int) {
            Logger.d("onMenuItemClick , ${item.type.name}")
            when (item.type) {
                FloatFeature.FEATURE_MEMBER -> MemberActivity.start(mActivity!!)
            }
        }

        override fun onExpandMenu(hasRedDot: Boolean) {
            Logger.d("onExpandMenu")
        }

        override fun onDismissMenu() {
            floatingBall?.dismissMenu()
        }

    }

    override fun onCreate() {
        super.onCreate()
    }

    fun initService(activity: Activity) {
        this.mActivity = activity
    }

    fun attach() {
        if (mActivity == null) {
            return
        }

        if (floatingBall == null) {
            floatingBall = FloatingBall(mActivity!!, SdkBridgeImpl.isLand, callback)
        }
        floatingBall?.attach()
    }

    fun detach() {
        floatingBall?.detach()
    }

    fun release() {
        floatingBall?.release()
    }

    override fun onBind(intent: Intent?): IBinder {
        return FloatCenterServiceBinder()
    }

    override fun onStartCommand(intent: Intent?, flags: Int, startId: Int): Int {
        return super.onStartCommand(intent, flags, startId)
    }

    inner class FloatCenterServiceBinder : Binder() {
        val service: FloatCenterService = this@FloatCenterService
    }

}